<?php
class SearchObjectByFieldCustomSort
{
    function sort_and ( $results = array(), $params = array(),
        &$sorted, &$limit_offset, $ids = array() ) {
        foreach ( $results as $id => $field_values ) {
            $match_all = 1;
            foreach ( $params as $key => $values ) {
                $result = $results[ $id ][ $key ];
                if (! isset( $result ) ) {
                    $match_all = NULL;
                    break;
                }
            }
            if ( $match_all ) {
                $ids[] = $id;
            }
        }
        // $sorted = TRUE;
        // $limit_offset = FALSE;
        $ids = array_unique( $ids );
        return $ids;
    }
    function custom_sort ( $results = array(), $params = array(),
        &$sorted, &$limit_offset, $ids = array() ) {
        // Custom Sort and Set Limit and Offset
        if ( isset( $_REQUEST[ 'sort_by' ] ) && ( $_REQUEST[ 'sort_by' ] ) ) {
            $sort_by = $_REQUEST[ 'sort_by' ];
            $sort_by = str_replace( '_', '.', $sort_by );
            $sort_by = preg_replace( '/^field\./', '', $sort_by );
            if (! isset( $params[ $sort_by ] ) ) {
                $sort_by = NULL;
            }
        }
        if ( isset( $_REQUEST[ 'offset' ] ) && ( $_REQUEST[ 'offset' ] ) ) {
            $offset = $_REQUEST[ 'offset' ] + 0;
        }
        if ( isset( $_REQUEST[ 'limit' ] ) && ( $_REQUEST[ 'limit' ] ) ) {
            $limit = $_REQUEST[ 'limit' ] + 0;
            if (! $offset ) $offset = 0;
        }
        if ( isset( $_REQUEST[ 'sort_order' ] ) && ( $_REQUEST[ 'sort_order' ] ) ) {
            $sort_order = $_REQUEST[ 'sort_order' ];
        }
        if ( (! $sort_order ) || ( $sort_order == 'descend' ) ) {
            $sort_order = 'DESC';
        } else {
            $sort_order = 'ASC';
        }
        $sort_ids;
        $filter_conditions;
        /*
        $filter_conditions = array(
            'and' => array(
                array( 'key' => 'customobjecttest1', 'condition' => '>', 'value' => 0 ),
                array( 'key' => 'customobjecttest2', 'condition' => '=', 'value' => 1 ) ),
            'or' => array(
                array( 'key' => 'customobjecttest1', 'condition' => '=', 'value' => 1 ),
                array( 'key' => 'customobjecttest1', 'condition' => '>', 'value' => 0 ) )
            );
        */
        $default_value;
        if ( $sort_by ) {
            $sort_col = $params[ $sort_by ][ 'column_def' ];
            if ( strpos( $sort_col, 'integer' ) !== FALSE ) {
                $bulk_sort_type = 'integer';
                $default_value = 0;
            } else if ( strpos( $sort_col, 'float' ) !== FALSE ) {
                $bulk_sort_type = 'integer';
                $default_value = 0;
            } else if ( strpos( $sort_col, 'datetime' ) !== FALSE ) {
                $bulk_sort_type = 'string';
                $mt = MT::get_instance();
                $default_value = $mt->db()->ts2db( '00000000000000' );
            } else {
                $bulk_sort_type = 'string';
                $default_value = '';
            }
        }
        foreach ( $results as $id => $field_values ) {
            // Add Some Filter condition
            if ( $filter_conditions ) {
                if (! $this->custom_filter( $filter_conditions, $field_values ) ) {
                    CONTINUE;
                }
            }
            $ids[] = $id;
            if ( $sort_by ) {
                if ( isset( $field_values[ $sort_by ] ) ) {
                    $sort_ids[ $id ] = $field_values[ $sort_by ];
                } else {
                    $sort_ids[ $id ] = $default_value;
                }
            }
        }
        if ( $sort_by ) {
            if ( $bulk_sort_type == 'integer' ) {
                if ( $sort_order == 'ASC' ) {
                    asort( $sort_ids, SORT_NUMERIC );
                } else {
                    arsort( $sort_ids, SORT_NUMERIC );
                }
            } else {
                if ( $sort_order == 'ASC' ) {
                    asort( $sort_ids );
                } else {
                    arsort( $sort_ids );
                }
            }
            $ids = array_keys( $sort_ids );
            $sorted = TRUE;
        }
        $ids = array_unique( $ids );
        if ( isset( $limit ) ) {
            $ids = array_slice( $ids , $offset, $limit );
            $limit_offset = FALSE;
        }
        return $ids;
    }
    function custom_filter( $filter_conditions, $field_values, $id = NULL ) {
        $result = TRUE;
        $match_all = TRUE;
        if ( isset( $filter_conditions[ 'and' ] ) ) {
            $and = $filter_conditions[ 'and' ];
            foreach( $and as $filter ) {
                $key = $filter[ 'key' ];
                $value = $filter[ 'value' ];
                $condition = $filter[ 'condition' ];
                if (! isset( $field_values[ $key ] ) ) {
                    return FALSE;
                }
                $comp = $field_values[ $key ];
                if ( $condition == '=' ) {
                    if ( $comp == $value ) {
                    } else {
                        return FALSE;
                    }
                } elseif ( $condition == '>' ) {
                    if ( $comp > $value ) {
                    } else {
                        return FALSE;
                    }
                } elseif ( $condition == '<' ) {
                    if ( $comp < $value ) {
                    } else {
                        return FALSE;
                    }
                } elseif ( $condition == '>=' ) {
                    if ( $comp >= $value ) {
                    } else {
                        return FALSE;
                    }
                } elseif ( $condition == '<=' ) {
                    if ( $comp <= $value ) {
                    } else {
                        return FALSE;
                    }
                } elseif ( $condition == 'LIKE' ) {
                    $value = str_replace( '%', '', $value );
                    if ( strpos( $comp, $value ) !== FALSE ) {
                    } else {
                        return FALSE;
                    }
                } elseif ( $condition == 'NOT LIKE' ) {
                    $value = str_replace( '%', '', $value );
                    if ( strpos( $comp, $value ) === FALSE ) {
                    } else {
                        return FALSE;
                    }
                }
            }
        }
        if ( isset( $filter_conditions[ 'or' ] ) ) {
            $or = $filter_conditions[ 'or' ];
            foreach( $or as $filter ) {
                $key = $filter[ 'key' ];
                $value = $filter[ 'value' ];
                $condition = $filter[ 'condition' ];
                if (! isset( $field_values[ $key ] ) ) {
                    return FALSE;
                }
                $comp = $field_values[ $key ];
                if ( $condition == '=' ) {
                    if ( $comp == $value ) {
                        return TRUE;
                    }
                } elseif ( $condition == '>' ) {
                    if ( $comp > $value ) {
                        return TRUE;
                    }
                } elseif ( $condition == '<' ) {
                    if ( $comp < $value ) {
                        return TRUE;
                    }
                } elseif ( $condition == '>=' ) {
                    if ( $comp >= $value ) {
                        return TRUE;
                    }
                } elseif ( $condition == '<=' ) {
                    if ( $comp <= $value ) {
                        return TRUE;
                    }
                } elseif ( $condition == 'LIKE' ) {
                    $value = str_replace( '%', '', $value );
                    if ( strpos( $comp, $value ) !== FALSE ) {
                        return TRUE;
                    }
                } elseif ( $condition == 'NOT LIKE' ) {
                    $value = str_replace( '%', '', $value );
                    if ( strpos( $comp, $value ) === FALSE ) {
                        return TRUE;
                    }
                }
                return FALSE;
            }
        }
        return $match_all;
    }
}
?>